'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _ViewBase = require('tooey/lib/ViewBase');

var _ViewBase2 = _interopRequireDefault(_ViewBase);

var _Menu = require('tooey/lib/Menu');

var _Menu2 = _interopRequireDefault(_Menu);

var _MenuOption = require('tooey/lib/MenuOption');

var _MenuOption2 = _interopRequireDefault(_MenuOption);

var _Output = require('cashlib/lib/Output');

var _Output2 = _interopRequireDefault(_Output);

var _app = require('../app');

var _app2 = _interopRequireDefault(_app);

var _OutputsList = require('../components/OutputsList');

var _OutputsList2 = _interopRequireDefault(_OutputsList);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

class SelectOutput extends _ViewBase2.default {

  constructor(outputs, onSelected) {
    super('Select Output');

    this._outputs = outputs;
    const ok = new _MenuOption2.default('O', 'OK', 'Continue with selected output', this.onOk.bind(this));
    this._menu = new _Menu2.default(_app2.default, [ok], true);
    this._outputsList = new _OutputsList2.default(outputs, this._menu, true);
    this._onSelected = onSelected;
  }

  async onOk() {
    await this._onSelected(this._outputsList.selectedOutputIndex);
  }

  render() {
    this._outputsList.render();
    this._menu.render(false);
  }

  async handle(input) {
    await this._outputsList.handle(input);
    await this._menu.handle(input);
  }
}
exports.default = SelectOutput;